<script setup>
    import JetButton from '@/Jetstream/Button.vue';
    import JetDangerButton from '@/Jetstream/DangerButton.vue';

    import AppLayout from '@/Layouts/AppLayout.vue';
    import InfiniteLoading from "v3-infinite-loading";
    import "v3-infinite-loading/lib/style.css"; //required if you're not going to override default slots
    import { Link } from '@inertiajs/inertia-vue3';

</script>

<template>
    <AppLayout title="Network">
        <template #header>

            <div class="flex items-center">



            <div class="w-full" >
            <h2 class="font-semibold text-xl text-gray-800 leading-tight w-1/2">
                Network
            </h2>

            </div>

            </div>
        </template>

        <div class="py-12">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8"  >
                <div class="flex flex-col items-center bg-white rounded-lg border shadow-md md:flex-row  hover:bg-gray-100 dark:border-gray-700 dark:bg-gray-800 dark:hover:bg-gray-700 m-3" v-for="user in network" :key="user.id">
                    <img class="object-cover w-full h-96 rounded-t-lg md:h-auto md:w-48 md:rounded-none md:rounded-l-lg" v-if="user.profile_photo_url !== null" :src="user.profile_photo_url" >
                    <div class="flex flex-col justify-between p-4 leading-normal">
                        <h5 class="mb-2 text-2xl font-bold tracking-tight text-gray-900 dark:text-white">{{user.name}}</h5>

                        <p class="italic mb-3 font-normal text-gray-700 dark:text-gray-400" v-if="user.job_title !== null">
                            {{user.job_title}}
                        </p>

                        <p class="mb-3 font-normal text-gray-700 dark:text-gray-400">
                            <JetDangerButton @click="unFollow(user.id)" v-if="loggedInUserInFollowers(user)">
                                UnFollow
                            </JetDangerButton>
                            <JetButton @click="follow(user.id)" v-else>
                                Follow
                            </JetButton>


                        </p>
                    </div>
                    <div class="flex flex-col grid  w-full justify-items-center md:justify-items-end ">
                        <a :href="'mailto:'+user.email">
                        <svg xmlns="http://www.w3.org/2000/svg" class="h-12 md:mr-2" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                            <path stroke-linecap="round" stroke-linejoin="round" d="M3 8l7.89 5.26a2 2 0 002.22 0L21 8M5 19h14a2 2 0 002-2V7a2 2 0 00-2-2H5a2 2 0 00-2 2v10a2 2 0 002 2z" />
                        </svg>
                        </a>
                    </div>
                </div>


                    <InfiniteLoading :network="network" @infinite="load">
                        <template #complete>
                            <span></span>
                        </template>
                    </InfiniteLoading>


            </div>
        </div>
    </AppLayout>
</template>

<script>
    export default {
        name: "Index",
        data(){
            return {
                network:[],
                page:1,
            }
        },
        methods:{
            async load($state) {

                let here = this;

                try {
                    const response = await fetch(route('network.index',{page:here.page}));
                    const json = await response.json();

                    here.network.push(...json.data);
                    $state.loaded();



                    if (_.isEmpty(json.next_page_url))
                    {
                        $state.complete();
                    }
                    else {
                        here.page++;
                    }

                } catch (error) {
                    $state.error();
                }
            },
            follow(userId){
                axios.post(route('network.follow',{user:userId}));
                this.$inertia.get(route('network'));
            },
            unFollow(userId)
            {
                axios.post(route('network.unfollow',{user:userId}));
                this.$inertia.get(route('network'));
            },
            loggedInUserInFollowers(user){

                if(!_.isEmpty(_.find(user.followers,{id:this.$page.props.user.id})))
                {
                    return true;
                }

                return false;
            }


        },
    }
</script>

<style scoped>
    .result {
        display: flex;
        flex-direction: column;
        gap: 5px;
        font-weight: 300;
        width: 400px;
        padding: 10px;
        text-align: center;
        margin: 0 auto 10px auto;
        background: #eceef0;
        border-radius: 10px;
    }
</style>